#!/bin/bash
#
# detectdevices.sh
#
# Usage: devicefile.sh <device file> <temp file> <log file>
#
# Return Codes:
#
# Module History:
#  00  12/28/2004  P. Provost  Initial release
#  01  03/17/2005  P. Provost  Fixed tracing

PARMS=$1
TEMPFILE=$2
LOGFILE=$3

echo "-> detectdevices.sh" >> $LOGFILE
echo "detectdevices.sh: Detecting media devices for `date`" >> $LOGFILE

actzTrace "XMDA   T: -> detectdevices.sh"
actzTrace "XMDA   F: detectdevices.sh: Detecting media devices for `date`"

# run the SUSE hwinfo command and pass it the appropriate parameters 
if /usr/sbin/hwinfo $PARMS > $TEMPFILE; then
    
    # copy the output of the hwinfo command to the log file
    echo "" >> $LOGFILE    
    cat $TEMPFILE >> $LOGFILE
    echo "" >> $LOGFILE    

    echo "<- detectdevices.sh" >> $LOGFILE
    echo "" >> $LOGFILE    
    
    actzTrace "XMDA   T: <- detectdevices.sh"
    
    exit 0

# Else the script to detect devices failed         
else
    
    echo "detectdevices.sh Error detecting devices" >> $LOGFILE
    actzTrace "XMDA   F: detectdevices.sh: Error detecting devices."
    
    echo "<- detectdevices.sh" >> $LOGFILE
    echo "" >> $LOGFILE
    
    actzTrace "XMDA   T: <- detectdevices.sh"
    
    exit 1
fi
 

